import exceptions, sys, psyco, cgi,time, urllib, PyLucene
import Modules.HTTPInterface as HTTPInterface
import Modules.HTTPProcessor as HTTPProcessor

from threading import Thread, Event
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer

#host ip
host = '127.0.0.1'
#host port
port = 81

class SocketException(exceptions.Exception):
    def __init__(self, args=None):
        self.args=args

#HTTP handled, listens for connections,receives data and return data
class HTTP:
    def __init__(self):
        self.addr = None
        self.timeout = 10        
        self.server = HTTPServer(('', port), self.MyHandler)
        self.serverThread = PyLucene.PythonThread(target = self.HTTPServerThread)
        self.serverThread.start()

    def HTTPServerThread(self):
        self.server.serve_forever()

    class MyHandler(BaseHTTPRequestHandler):
        def do_GET(self):
            sTime = time.time()
            argdict = {}
            where = ""
            queries = []
            html = ""
            try:
            	#parse input data
                path = self.path.split("?")
                if len(path) > 1:
                    file = path[0].split("/")
                    args = path[1].split("&")
                    for arg in args:
                        thisarg = arg.split("=")
                        argdict[thisarg[0]] = thisarg[1]
                #unquote input data
                where = urllib.unquote_plus(argdict.get("where1", "").strip())
                #up to three queries possible (advanced)
                queries.append(urllib.unquote_plus(argdict.get("query1", "")).strip())
                queries.append(urllib.unquote_plus(argdict.get("query2", "")).strip())
                queries.append(urllib.unquote_plus(argdict.get("query3", "")).strip())
                if argdict.get("action", "") == "Browse": #browse documents
                    html = processor.browse(argdict)
                    html = interface.pageSearchBarTopBrowse(sTime, path) + html
                elif argdict.get("action", "Search") == "Search" and (argdict.get("type", "simple") == "simple" or argdict.get("type", "") == "advanced"): #sarch for documents
                    (resultCount, html) = processor.createSearch(argdict)
                    if not queries[0] == "" or not queries[1] == "" or not queries[2] == "":
                        html = interface.pageSearchBarTopSearch(sTime, resultCount, processor.reader.numDocs(), argdict.get("type", "simple"), queries) + html
            except Exception, e:
                print "MyHandler 1: %s" % e

            try: #generate page and send to client
                self.send_response(200)
                self.send_header('Content-type',    'text/html')
                self.end_headers()
                page = ""
                page += interface.pageHead()
                if argdict.get("type", "") == "advanced":
                    page += interface.pageSearchAdvanced(where, queries, argdict)
                else:
                    page += interface.pageSearchSimple(queries, argdict)
                page += html
                if html:
                    page += interface.pageSearchBarBottom()
                else:
                    page += interface.pageBottom()
                self.wfile.write(page)
            except Exception,e:
                print "MyHandler 2: %s" % e
            return

#invoke optimizer
psyco.full()
interface = HTTPInterface.HTTPInterface() #interface design
processor = HTTPProcessor.HTTPProcessor(host, port) #does the actual prosessing of queries
HTTP() #start HTTP server
#processor.Close()