import sys, sre, pickle, zlib, marshal, cPickle, os, glob

sre_html = sre.compile("(?s)<[^>]*>|&#?\w+;")
sre_punctuation = sre.compile('\.\,\:\;\?\!\"')
sre_separators = sre.compile("""\n\!\"\#\$\%\&\'\(\)\*\+\,\-\.\/\:\;\<\=\>\?\@\[\\\]\^\_\`\{\|\}\~""")

def intersection(dict1, dict2):
    "Returns intersection of the two dictionaries."
    int_dict = {}
    if len(dict1) > len(dict2): 
        for e in dict2.keys():
            if dict1.has_key(e):
                int_dict[e] = dict2[e] + dict1[e]
    else:
        for e in dict1.keys():
            if dict2.has_key(e):
                int_dict[e] = dict2[e] + dict1[e]
    return int_dict
    
def serialize_via_marshal(obj):
    """Serialize Python object via marshal into a compressed string."""
    return zlib.compress(marshal.dumps(obj))
def deserialize_via_marshal(string):
    """Decompress and deserialize string into a Python object via marshal."""
    return marshal.loads(zlib.decompress(string))
def serialize_via_pickle(obj):
    """Serialize Python object via marshal into a compressed string."""
    return zlib.compress(cPickle.dumps(obj))
def deserialize_via_pickle(string):
    """Decompress and deserialize string into a Python object via marshal."""
    return cPickle.loads(zlib.decompress(string))
   
#Delete files in directory
def deleteFiles(directory):
    files = glob.glob(directory + "\\*")
    for file in files:
        os.remove(file)       