from PyLucene import Token
from NumberUtils import NumberUtils

class yearFilter(object):

    def __init__(self, tokenStream):
        self.input = tokenStream

    #pads years to a predefined size so that alphabetical comparision can be done
    def next(self):
        token = self.input.next()
        if token is None:
            return None
        return Token(NumberUtils.pad(int(token.termText())),token.startOffset(), token.endOffset(), token.type()) 